---
title: document
slug: Web/XPath/Functions/document
tags:
  - XSLT
  - XSLT_Reference
---
<p>{{ XsltRef() }}</p>

<p><br>
 The <code>document</code> finds a node-set in an external document, or multiple external documents, and returns the resulting node-set.</p>

<h3 id="Syntax">Syntax</h3>

<pre class="eval">document(<em>URI</em> [,<em>node-set</em>] )
</pre>

<h3 id="Arguments">Arguments</h3>

<dl>
 <dt><code><em>URI</em> </code></dt>
 <dd>An absolute or relative URI of the document to be retrieved. The URI may also include a fragment identifier.</dd>
</dl>

<dl>
 <dt><code><em>node-set</em> </code> (optional)</dt>
 <dd>An expression pointing to a node-set in the external document that should be returned.</dd>
</dl>

<h3 id="Returns">Returns</h3>

<p>A node-set.</p>

<h3 id="Notes">Notes</h3>

<ul>
 <li>If the URI contains a fragment identifier and that fragment can be identified in the external document, that fragment will be treated as the root in the <code><em>node-set</em> </code> argument's expression. If the <code><em>node-set</em> </code> argument is omitted, the entire fragment will be returned.</li>
</ul>

<ul>
 <li>If the <code><em>URI</em> </code> argument is a node-set, and the second argument is present, each node in the node-set will be evaluated as a separate URI, and the returned node-set will be as if the <code>document</code> function has been called multiple times (each time with the same second argument just as given in the function call) and the resulting node-sets had been concatenated into a single node-set.</li>
</ul>

<ul>
 <li>Other specific conditions exist with specified behaviors. See the XSLT 1.0 documentation for details.</li>
</ul>

<ul>
 <li>Since the URI is relative to the XSL document, <code>document("")</code> would return the root node of the current document.</li>
</ul>

<p>This function is an XSLT-specific addition to XPath. It is not a part of the core XPath function library.</p>

<h3 id="Defined">Defined</h3>

<p><a class="external" href="http://www.w3.org/TR/xslt#function-document">XSLT 1.0 12.1</a></p>

<h3 id="Gecko_support">Gecko support</h3>

<p>Supported.</p>
